set define off
set verify off
set feedback off
WHENEVER SQLERROR EXIT SQL.SQLCODE ROLLBACK
begin wwv_flow.g_import_in_progress := true; end;
/
 
--       AAAA       PPPPP   EEEEEE  XX      XX
--      AA  AA      PP  PP  EE       XX    XX
--     AA    AA     PP  PP  EE        XX  XX
--    AAAAAAAAAA    PPPPP   EEEE       XXXX
--   AA        AA   PP      EE        XX  XX
--  AA          AA  PP      EE       XX    XX
--  AA          AA  PP      EEEEEE  XX      XX
prompt  Set Credentials...
 
begin
 
  -- Assumes you are running the script connected to SQL*Plus as the Oracle user APEX_040200 or as the owner (parsing schema) of the application.
  wwv_flow_api.set_security_group_id(p_security_group_id=>nvl(wwv_flow_application_install.get_workspace_id,3898325943721177));
 
end;
/

begin wwv_flow.g_import_in_progress := true; end;
/
begin 

select value into wwv_flow_api.g_nls_numeric_chars from nls_session_parameters where parameter='NLS_NUMERIC_CHARACTERS';

end;

/
begin execute immediate 'alter session set nls_numeric_characters=''.,''';

end;

/
begin wwv_flow.g_browser_language := 'en'; end;
/
prompt  Check Compatibility...
 
begin
 
-- This date identifies the minimum version required to import this file.
wwv_flow_api.set_version(p_version_yyyy_mm_dd=>'2012.01.01');
 
end;
/

prompt  Set Application ID...
 
begin
 
   -- SET APPLICATION ID
   wwv_flow.g_flow_id := nvl(wwv_flow_application_install.get_application_id,102);
   wwv_flow_api.g_id_offset := nvl(wwv_flow_application_install.get_offset,0);
null;
 
end;
/

prompt  ...ui types
--
 
begin
 
null;
 
end;
/

prompt  ...plugins
--
--application/shared_components/plugins/process_type/auditprocess
 
begin
 
wwv_flow_api.create_plugin (
  p_id => 55315944609639242 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_type => 'PROCESS TYPE'
 ,p_name => 'AUDITPROCESS'
 ,p_display_name => 'AuditProcess'
 ,p_supported_ui_types => 'DESKTOP:JQM_SMARTPHONE'
 ,p_image_prefix => '#PLUGIN_PREFIX#'
 ,p_plsql_code => 
'PROCEDURE create_hist_table('||unistr('\000a')||
'    p_table VARCHAR2)'||unistr('\000a')||
'IS'||unistr('\000a')||
'  l_c   INTEGER;'||unistr('\000a')||
'  l_sql VARCHAR2(500);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'  APEX_DEBUG.LOG_MESSAGE( p_message => ''Plug-In Audit ( create_hist_table) : Start '', p_level => 1);'||unistr('\000a')||
''||unistr('\000a')||
'  SELECT COUNT(TABLE_NAME)'||unistr('\000a')||
'  INTO l_c'||unistr('\000a')||
'  FROM user_tables'||unistr('\000a')||
'  WHERE TABLE_NAME = p_table'||unistr('\000a')||
'    || ''_H'';'||unistr('\000a')||
'  IF l_c = 0 THEN'||unistr('\000a')||
'    -- tabelle anlegen'||unistr('\000a')||
'   l_sql := ''create table '' || p_table || ''_H as SELECT sy'||
'sdate hist_timestamp, '' || '''''''' || ''INITIAL'' || '''''''' || '' as state  ,x.* FROM '' || p_table || '' x'';'||unistr('\000a')||
'   APEX_DEBUG.LOG_MESSAGE( p_message => ''Plug-In Audit ( create_hist_table) : l_sql = '' || l_sql , p_level => 1);'||unistr('\000a')||
''||unistr('\000a')||
'    EXECUTE immediate l_sql ;'||unistr('\000a')||
''||unistr('\000a')||
'    APEX_DEBUG.LOG_MESSAGE( p_message => ''Plug-In Audit ( create_hist_table) : Table Createted '', p_level => 1);'||unistr('\000a')||
''||unistr('\000a')||
'    -- Constraints eaktivieren'||unistr('\000a')||
'    FOR e'||
'x IN  (SELECT ''alter table '''||unistr('\000a')||
'                     || table_name'||unistr('\000a')||
'                     ||'' disable constraint '''||unistr('\000a')||
'                     || constraint_name AS sql_stmt'||unistr('\000a')||
'                  FROM user_constraints'||unistr('\000a')||
'                   WHERE table_name = p_table || ''_H''               )'||unistr('\000a')||
'    LOOP'||unistr('\000a')||
'      EXECUTE immediate ex.sql_stmt;    '||unistr('\000a')||
'    END LOOP; '||unistr('\000a')||
''||unistr('\000a')||
'   APEX_DEBUG.LOG_MESSAGE( p_message => ''Plug-In Audit ( creat'||
'e_hist_table) : constranits disabled'', p_level => 1);'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
'END;'||unistr('\000a')||
''||unistr('\000a')||
'PROCEDURE fill_hist_table('||unistr('\000a')||
'    p_table     VARCHAR2,'||unistr('\000a')||
'    p_id_column VARCHAR2,'||unistr('\000a')||
'    p_id_item   VARCHAR2)'||unistr('\000a')||
'IS'||unistr('\000a')||
'  l_sql     VARCHAR2(2000);'||unistr('\000a')||
'  l_cnt_del INTEGER;'||unistr('\000a')||
'  l_state   VARCHAR2(10);'||unistr('\000a')||
'BEGIN'||unistr('\000a')||
'  l_state :='''';'||unistr('\000a')||
'  APEX_DEBUG.LOG_MESSAGE( p_message => ''Plug-In Audit ( fill_hist_table) : Start '', p_level => 1);'||unistr('\000a')||
' IF v(p_id_item) is not nu'||
'll THEN     '||unistr('\000a')||
'  -- Wurde der Datensatz gelöscht?'||unistr('\000a')||
'   l_sql  := ''select count(*) from '' || p_table || '' x WHERE '' || p_id_column || '' = '' || v(p_id_item);'||unistr('\000a')||
''||unistr('\000a')||
'   EXECUTE immediate l_sql  INTO l_cnt_del;'||unistr('\000a')||
''||unistr('\000a')||
'   IF l_cnt_del = 0 THEN'||unistr('\000a')||
'      l_state   := ''DEL'';'||unistr('\000a')||
'      l_sql     := ''INSERT INTO '' || p_table || ''_H  (HIST_TIMESTAMP, STATE, '' || p_id_column  || '') VALUES ( sysdate,'' || '''''''' || l_state || '''''''' ||'','||
' '' || v(p_id_item) || '')'';  '||unistr('\000a')||
'   ELSE    '||unistr('\000a')||
'      APEX_DEBUG.LOG_MESSAGE( p_message => ''Plug-In Audit ( fill_hist_table) : p_id_item '' || v(p_id_item), p_level => 1);'||unistr('\000a')||
'      -- Wurde ein  Datensatz geändert ?    '||unistr('\000a')||
'       l_state := ''CHANGED'';    '||unistr('\000a')||
''||unistr('\000a')||
'       l_sql := '''||unistr('\000a')||
'         INSERT INTO '' || p_table || ''_H SELECT sysdate,'||unistr('\000a')||
'           '' || '''''''' || l_state || '''''''' ||'','||unistr('\000a')||
'             x.*'||unistr('\000a')||
'          FROM '' || '||
'p_table || '' x'||unistr('\000a')||
'         WHERE '' || p_id_column || '' = '' || v(p_id_item);  '||unistr('\000a')||
'    END IF;'||unistr('\000a')||
''||unistr('\000a')||
'   APEX_DEBUG.LOG_MESSAGE( p_message => ''Plug-In Audit ( fill_hist_table) : '' || l_sql, p_level => 1);'||unistr('\000a')||
'   EXECUTE immediate l_sql;'||unistr('\000a')||
' END IF;    '||unistr('\000a')||
' '||unistr('\000a')||
''||unistr('\000a')||
'END;'||unistr('\000a')||
''||unistr('\000a')||
'function exec_audit_process ('||unistr('\000a')||
'    p_process in apex_plugin.t_process,'||unistr('\000a')||
'    p_plugin  in apex_plugin.t_plugin )'||unistr('\000a')||
'    return apex_plugin.t_process_exec_result'||unistr('\000a')||
'is '||unistr('\000a')||
''||
'  l_result                      apex_plugin.t_process_exec_result;'||unistr('\000a')||
'  l_table_name                     varchar2(32) :=  p_process.attribute_03;'||unistr('\000a')||
'  l_id_item_name                   varchar2(50) :=  p_process.attribute_04;'||unistr('\000a')||
'  l_id_column                      varchar2(32) :=  p_process.attribute_05;'||unistr('\000a')||
'begin'||unistr('\000a')||
'  -- Wenn Debung eingeschaltet, erst einmal die Parameter ausgeben'||unistr('\000a')||
'  -- gerade während der Entwickl'||
'ung von Plug/ins ist ds sehr nützlich'||unistr('\000a')||
'  IF APEX_APPLICATION.g_debug THEN'||unistr('\000a')||
'     apex_plugin_util.debug_process (    p_plugin         => p_plugin,    p_process        => p_process);'||unistr('\000a')||
'  END IF;'||unistr('\000a')||
'  '||unistr('\000a')||
'  -- Hist Tabelle anlegen, wenn diese nicht existiert'||unistr('\000a')||
'   create_hist_table(l_table_name);'||unistr('\000a')||
''||unistr('\000a')||
'  -- Nun die Daten Historisieren'||unistr('\000a')||
'   fill_hist_table('||unistr('\000a')||
'    l_table_name    ,'||unistr('\000a')||
'     l_id_column    ,'||unistr('\000a')||
'     l_id_item_name '||
' );'||unistr('\000a')||
''||unistr('\000a')||
'    return l_result;'||unistr('\000a')||
'end;'
 ,p_execution_function => 'exec_audit_process '
 ,p_substitute_attributes => true
 ,p_subscribe_plugin_settings => true
 ,p_help_text => '<p>'||unistr('\000a')||
'	Audit</p>'||unistr('\000a')||
'<p>'||unistr('\000a')||
'	Journalizes all changes of a form in a journal table.</p>'||unistr('\000a')||
'<p>'||unistr('\000a')||
'	About the plug/in:</p>'||unistr('\000a')||
'<p>'||unistr('\000a')||
'	The audit process Plug/In is a process type Plug/in that can be used in an APEX form. It extends the functionality auf the dml-process. When the plug/in is started at the first time, it generates an audit table. After that, all changes of the source data will be journalized in this table.</p>'||unistr('\000a')||
'<p>'||unistr('\000a')||
'	How to use the plug/in</p>'||unistr('\000a')||
'<ol>'||unistr('\000a')||
'	<li>'||unistr('\000a')||
'		Install the Plug/in.</li>'||unistr('\000a')||
'	<li>'||unistr('\000a')||
'		Open the Form-Site in the application builder</li>'||unistr('\000a')||
'	<li>'||unistr('\000a')||
'		Create a new process.</li>'||unistr('\000a')||
'	<li>'||unistr('\000a')||
'		Choose the processtype: plug/ins</li>'||unistr('\000a')||
'	<li>'||unistr('\000a')||
'		Select the Audit-Process plug/in.</li>'||unistr('\000a')||
'	<li>'||unistr('\000a')||
'		Give it a name.</li>'||unistr('\000a')||
'	<li>'||unistr('\000a')||
'		Set the properties: Tabelle (table): &lt;database source table&gt;, ID_Item: &lt;item name&gt; (e.g. P10_ID), ID-Spalte (Id-Column): &lt;the primary key column&gt; (e.g. ID )</li>'||unistr('\000a')||
'	<li>'||unistr('\000a')||
'		Create the plug/in</li>'||unistr('\000a')||
'</ol>'||unistr('\000a')||
'<p>'||unistr('\000a')||
'	More &hellip;</p>'||unistr('\000a')||
'<p>'||unistr('\000a')||
'	I&rsquo;ve developed this and some more Plug/Ins as&nbsp; examples for my book <a href="http://www.amazon.de/gp/product/3446438963" target="_blank">&ldquo;Oracle Application Express in der Praxis&rdquo;. (ISBN: 978-3-446-43896-5 )</a>. Have a look at this book for more information and the technical background.</p>'||unistr('\000a')||
'<p>'||unistr('\000a')||
'	License:</p>'||unistr('\000a')||
'<p>'||unistr('\000a')||
'	Use the Audit Plug/In under the MIT license.</p>'||unistr('\000a')||
'<p>'||unistr('\000a')||
'	The MIT License (MIT)</p>'||unistr('\000a')||
'<p>'||unistr('\000a')||
'	Copyright (c) 2013 Ralf Beckmann (Eslohe, Germany)</p>'||unistr('\000a')||
'<p>'||unistr('\000a')||
'	Permission is hereby granted, free of charge, to any person obtaining a copy<br />'||unistr('\000a')||
'	of this software and associated documentation files (the &quot;Software&quot;), to deal<br />'||unistr('\000a')||
'	in the Software without restriction, including without limitation the rights<br />'||unistr('\000a')||
'	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell<br />'||unistr('\000a')||
'	copies of the Software, and to permit persons to whom the Software is<br />'||unistr('\000a')||
'	furnished to do so, subject to the following conditions:</p>'||unistr('\000a')||
'<p>'||unistr('\000a')||
'	The above copyright notice and this permission notice shall be included in<br />'||unistr('\000a')||
'	all copies or substantial portions of the Software.</p>'||unistr('\000a')||
'<p>'||unistr('\000a')||
'	THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR<br />'||unistr('\000a')||
'	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,<br />'||unistr('\000a')||
'	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE<br />'||unistr('\000a')||
'	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER<br />'||unistr('\000a')||
'	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,<br />'||unistr('\000a')||
'	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN<br />'||unistr('\000a')||
'	THE SOFTWARE.</p>'||unistr('\000a')||
''
 ,p_version_identifier => '1.0'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 5219715077815099 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 55315944609639242 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 3
 ,p_display_sequence => 30
 ,p_prompt => 'Tabelle'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => true
 ,p_is_translatable => false
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 5220006666819016 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 55315944609639242 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 4
 ,p_display_sequence => 40
 ,p_prompt => 'ID-Item'
 ,p_attribute_type => 'PAGE ITEM'
 ,p_is_required => true
 ,p_is_translatable => false
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 5220302784820816 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 55315944609639242 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 5
 ,p_display_sequence => 50
 ,p_prompt => 'ID-Spalte'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => true
 ,p_is_translatable => false
  );
null;
 
end;
/

commit;
begin
execute immediate 'begin sys.dbms_session.set_nls( param => ''NLS_NUMERIC_CHARACTERS'', value => '''''''' || replace(wwv_flow_api.g_nls_numeric_chars,'''''''','''''''''''') || ''''''''); end;';
end;
/
set verify on
set feedback on
set define on
prompt  ...done
